C 
C
      SUBROUTINE MAP_CRYSTAL_TENSOR6(F,G,AP,BP,CP,ALPH,BETA,GAMM,PI,IFAIL)
      REAL F(9),G(9),AP,BP,CP,ALPH,BETA,GAMM,PI
      INTEGER IFAIL,I
C
C Calculates the metric tensor and its inverse for an
C TRICLINIC crystal structure.
C
C The metric tensor F converts the components from reciprocal to
C  real space. 
C The metric tensor G converts the components from real to reciprocal
C  space, and G is the inverse of F and vice-versa.
C
C Adapted from subroutine CRYSTAL of the interactive program MAP_CRYSTAL_PROGRAM.
C
C
      DO 20 I=1,9
      G(I)=0.0D+00
      F(I)=0.0D+00
 20   CONTINUE
C
      IFAIL=0
      IF (ALPH .LT. 0.0 .OR. ALPH .GT. 180.0) IFAIL=1
      IF (BETA .LT. 0.0 .OR. BETA .GT. 180.0) IFAIL=1
      IF (GAMM .LT. 0.0 .OR. GAMM .GT. 180.0) IFAIL=1
      IF (IFAIL .EQ. 1) GOTO 40
          CALL MAP_CRYSTAL_MET6(G,AP,BP,CP,ALPH,BETA,GAMM,PI,IFAIL)
          CALL MAP_UTIL_INVERS(F,G)

C
 40    RETURN
       END
